------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision$ $Date$
------------------------------------------------------------------------------

package body Qt4.Item_Selections is

   function new_QItemSelection return not null access Qt4_Entities.Cpp_Class;
   pragma Import (C, new_QItemSelection, "__Qt4Ada_new_QItemSelection");

   procedure assign_QItemSelection
    (S_1 : not null access          Thin.QItemSelection;
     S_2 : not null access constant Thin.QItemSelection);
   pragma Import (C, assign_QItemSelection, "__Qt4Ada_assing_QItemSelection");

   function count_wrapper (Self : not null access Thin.QItemSelection)
     return Interfaces.C.int;
   pragma Import (C, count_wrapper, "__Qt4Ada_QItemSelection_count_wrapper");

   procedure delete_QItemSelection
    (Cpp_Object : not null access Qt4_Entities.Cpp_Class);
   pragma Import (C, delete_QItemSelection, "__Qt4Ada_delete_QItemSelection");

   procedure at_wrapper
    (Self : not null access Thin.QItemSelection;
     Pos  : Interfaces.C.int;
     Ret  :
       not null access Qt4.Item_Selection_Ranges.Thin.QItemSelectionRange);
   pragma Import (C, at_wrapper, "__Qt4Ada_QItemSelection_at_wrapper");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Copy_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding
   function Copy_Cpp_Object (Self : not null access Q_Item_Selection)
     return not null access Qt4_Entities.Cpp_Class
   is
   begin
      return Thin.copy_QItemSelection (Self.Cpp_Object);
   end Copy_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Count
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Count (Self : Q_Item_Selection) return Q_Integer is
   begin
      return Q_Integer (count_wrapper (Internals.QItemSelection_View (Self)));
   end Count;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Create
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Create return Q_Item_Selection is
      Result : Q_Item_Selection;

   begin
      return Result;
   end Create;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Default_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding function Default_Cpp_Object
    (Self : not null access Q_Item_Selection)
       return access Qt4_Entities.Cpp_Class
   is
      pragma Unreferenced (Self);
      --  Параметр необходим для диспетчеризации надклассового вызова.

   begin
      return new_QItemSelection;
   end Default_Cpp_Object;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Delete_Cpp_Object
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   overriding
   procedure Delete_Cpp_Object (Self : not null access Q_Item_Selection)
   is
   begin
      delete_QItemSelection (Self.Cpp_Object);
   end Delete_Cpp_Object;

   package body Internals is

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> QItemSelection_View
      --!    <ImplementationNotes>
      ------------------------------------------------------------------------
      function QItemSelection_View (Self : Q_Item_Selection)
        return not null access Thin.QItemSelection
      is
      begin
         return Qt4_Entities.Cpp_Object (Self);
      end QItemSelection_View;

      ------------------------------------------------------------------------
      --! <Subprogram>
      --!    <Unit> To_Q_Item_Selection
      --!    <ImplementationNotes>
      ------------------------------------------------------------------------
      function To_Q_Item_Selection
       (Item : not null access constant Thin.QItemSelection)
          return Q_Item_Selection
      is
      begin
         return Result : Q_Item_Selection do
            assign_QItemSelection
             (Internals.QItemSelection_View (Result), Item);
         end return;
      end To_Q_Item_Selection;

   end Internals;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Item_At
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
   function Item_At (Self : Q_Item_Selection; Pos : Q_Integer)
     return Qt4.Item_Selection_Ranges.Q_Item_Selection_Range
   is
   begin
      return Result : Qt4.Item_Selection_Ranges.Q_Item_Selection_Range do
         at_wrapper
          (Internals.QItemSelection_View (Self),
           Interfaces.C.int (Pos),
           Qt4.Item_Selection_Ranges.Internals.QItemSelectionRange_View
            (Result));
      end return;
   end Item_At;

end Qt4.Item_Selections;
